function displayScreePlot(lambdas)
% displayScreePlot(lambdas)]
% displays two graphs:
% top: (scree plot) graph of eigenvalue as a function of eigenvalue number
% bottom: cumulative plot of the percentage of the variance in the data
% that is explained, as a function of the number of eigenvectors considered

numTraining = length(lambdas);      % number of training image
figure
subplot(2, 1, 1)
plot(1:numTraining, lambdas, 'LineWidth', 2);   % top graph
xlabel('eigenvalue number');
ylabel('eigenvalue magnitude');
title('scree plot', 'FontSize', 16)
subplot(2, 1, 2)                                % bottom graph
plot(1:numTraining, 100 * cumsum(lambdas) ./ sum(lambdas), 'LineWidth', 2);
hold on
% also draw dashed line at 90% level
plot([1 numTraining], [90 90], '--k')
hold off
xlabel('eigenvalue number');
ylabel('cumulative % variance explained');
title('% variance explained', 'FontSize', 16)
set(gcf,'Name', 'scree plot');

end

