function varargout = facesGUI(varargin)
% FACESGUI MATLAB code for facesGUI.fig
%      FACESGUI, by itself, creates a new FACESGUI or raises the existing
%      singleton*.
%
%      H = FACESGUI returns the handle to a new FACESGUI or the handle to
%      the existing singleton*.
%
%      FACESGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FACESGUI.M with the given input arguments.
%
%      FACESGUI('Property','Value',...) creates a new FACESGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before facesGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to facesGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help facesGUI

% Last Modified by GUIDE v2.5 27-Oct-2016 08:14:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @facesGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @facesGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before facesGUI is made visible.
function facesGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to facesGUI (see VARARGIN)

% Choose default command line output for facesGUI
handles.output = hObject;

handles.timesPressed = 0;   % number of eigenfaces added to create image
handles.height = 243;       % height and width of yale face images
handles.width = 210;
handles.faces1 = [];        % sequence of faces created for left example
handles.faces2 = [];        % sequence of faces created for right example
handles.weights1 = [];      % weights for first and second face images
handles.weights2 = [];
% load all the training and test images into matrices
[handles.Xtrain, handles.Xnorm, handles.Xlight, handles.Xexp, handles.Xrot, ...
    handles.avgFace, handles.labelsTrain, handles.labelsTest, handles.nTrain] ...
    = getFaceData();
% run the PCA method to compute the eigenfaces
[handles.U, handles.lambdas] = computeEigenfaces(handles.Xnorm);
% initialize test case to left/right lighting tests (initial choice on GUI)
handles.Xtest = handles.Xlight;
handles.numPC = 25;         % number of eigenfaces (initial value on GUI)

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes facesGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = facesGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in viewDatasetBtn.
function viewDatasetBtn_Callback(hObject, eventdata, handles)
% hObject    handle to viewDatasetBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

displayDataPCA(handles.Xtrain', 15, 7, 350, 'Entire Training DataSet');

% --- Executes on button press in viewEigenvectorsBtn.
function viewEigenvectorsBtn_Callback(hObject, eventdata, handles)
% hObject    handle to viewEigenvectorsBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

displayDataPCA(handles.U(:, 1:25)', 5, 5, 600, 'First 25 Eigenfaces');

% --- Executes on button press in genFacesBtn.
function genFacesBtn_Callback(hObject, eventdata, handles)
% hObject    handle to genFacesBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.numPC = fix(str2double(get(handles.numFacesText, 'String')));
% generate indices for two examples that correspond to different subjects
index1 = randi(15,1);
index2 = randi(15,1);
while (index2 == index1)
    index2 = randi(15,1);
end
index1 = (index1-1)*7 + randi(7,1);
index2 = (index2-1)*7 + randi(7,1);
% compute two sequences of composite face images and associated weights
% (allows up to 50 eigenfaces to be added)
[handles.faces1, handles.weights1] = computeCumFaces(handles.Xtrain, ...
        handles.Xnorm, handles.avgFace, index1, handles.U, 50);
orig1 = reshape(handles.Xtrain(:, index1), handles.height, handles.width);
[handles.faces2, handles.weights2] = computeCumFaces(handles.Xtrain, ...
        handles.Xnorm, handles.avgFace, index2, handles.U, 50);
orig2 = reshape(handles.Xtrain(:, index2), handles.height, handles.width);
% display two original images at the top
axes(handles.axes1)
imshow(orig1, [])
axes(handles.axes2)
imshow(orig2, [])
% enable the "add eigenface" button and initialize it to 1
set(handles.addEigenBtn, 'String', 'Add Eigenface: 1');
set(handles.addEigenBtn, 'Enable', 'on')
% initially show average face in both axes at the bottom
meanFace = reshape(handles.avgFace, handles.height, handles.width);
axes(handles.axes3)
imshow(meanFace, [])
axes(handles.axes4)
imshow(meanFace, [])
% display first eigenface in the middle, with two associated weights
eig1 = reshape(handles.U(:, 1), handles.height, handles.width);
axes(handles.axes5)
imshow(eig1, [])
set(handles.weight1lab, 'String', sprintf('weight: %2.1f', handles.weights1(1)));
set(handles.weight2lab, 'String', sprintf('weight: %2.1f', handles.weights2(1)));
handles.timesPressed = 0;       % initialize number of eigenfaces added

% Update handles structure  
guidata(hObject, handles);

% --- Executes on button press in addEigenBtn.
function addEigenBtn_Callback(hObject, eventdata, handles)
% hObject    handle to addEigenBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% increment number of eigenfaces added and display next composite images
if (handles.timesPressed < 50)
    handles.timesPressed = handles.timesPressed + 1;    
    axes(handles.axes3)
    imshow(reshape(handles.faces1(2+handles.timesPressed, :), handles.height, handles.width), [])
    axes(handles.axes4)
    imshow(reshape(handles.faces2(2+handles.timesPressed, :), handles.height, handles.width), [])
end
if (handles.timesPressed == 50)
    % if number of eigenfaces shown on GUI has been reached, disable the
    % "add eigenface" button and clear the middle axes and text boxes
    set(handles.addEigenBtn, 'String', '-------');
    set(handles.addEigenBtn, 'Enable', 'off'); 
    axes(handles.axes5)
    cla
    set(handles.weight1lab, 'String', '')
    set(handles.weight2lab, 'String', '')
else
    % increment eigenface number and show next eigenface and two weights
    set(handles.addEigenBtn, 'String', ['Add Eigenface: ' num2str(1+handles.timesPressed)]);
    axes(handles.axes5)
    imshow(reshape(handles.U(:, 1+handles.timesPressed)', handles.height, handles.width), [])
    set(handles.weight1lab, 'String', sprintf('weight: %2.1f', handles.weights1(1+handles.timesPressed)));
    set(handles.weight2lab, 'String', sprintf('weight: %2.1f', handles.weights2(1+handles.timesPressed)));
end

% Update handles structure  
guidata(hObject, handles);

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close all
delete(handles.figure1)

% --- Executes on selection change in testMenu.
function testMenu_Callback(hObject, eventdata, handles)
% hObject    handle to testMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns testMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from testMenu

% --- Executes during object creation, after setting all properties.
function testMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to testMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function numFacesText_Callback(hObject, eventdata, handles)
% hObject    handle to numFacesText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numFacesText as text
%        str2double(get(hObject,'String')) returns contents of numFacesText as a double

handles.numPC = str2double(get(hObject, 'String'));

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function numFacesText_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numFacesText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in testButton.
function testButton_Callback(hObject, eventdata, handles)
% hObject    handle to testButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% assess performance of PCA method for selected test case
testChoice = get(handles.testMenu, 'Value');
if (testChoice == 1)
    handles.Xtest = handles.Xlight;     % left/right lighting test
elseif (testChoice == 2)
    handles.Xtest = handles.Xexp;       % happy/surprized expression test
else
    handles.Xtest = handles.Xrot;       % 15 deg rotation test
end
% get number of eigenfaces indicated on the GUI
handles.numPC = str2double(get(handles.numFacesText, 'String'));
% run the test to obtain the accuracy of classification
accuracy = runTest(handles.Xnorm, handles.Xtest, handles.avgFace, handles.U, ...
                    handles.numPC, handles.labelsTrain, handles.labelsTest);
set(handles.accuracyText, 'String', sprintf('Accuracy = %2.1f', accuracy))

% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in screeButton.
function screeButton_Callback(hObject, eventdata, handles)
% hObject    handle to screeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

displayScreePlot(handles.lambdas)  

% --- Executes on button press in viewTestButton.
function viewTestButton_Callback(hObject, eventdata, handles)
% hObject    handle to viewTestButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% view the images for the selected test case
testChoice = get(handles.testMenu, 'Value');
if (testChoice == 1)
    handles.Xtest = handles.Xlight;     % left/right lighting test
elseif (testChoice == 2)
    handles.Xtest = handles.Xexp;       % happy/surprised expression test
else
    handles.Xtest = handles.Xrot;       % 15 deg rotation test
end
displayDataPCA(handles.Xtest', 15, 2, 130, 'Test DataSet');

% Update handles structure
guidata(hObject, handles);
